SystemOrganization addCategory: #BattleShip!

Error subclass: #GridCollisionError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

Object subclass: #Cell
	instanceVariableNames: 'isHit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

Cell subclass: #BigCaptainCell
	instanceVariableNames: 'ship noOfHits'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

!BigCaptainCell methodsFor: 'accessing' stamp: 'YuLin 5/2/2013 16:54'!
getCharStatus
	super isHit
		ifTrue: [ 
			noOfHits = 1
				ifTrue: [ ^ 'x' ].
			noOfHits > 1
				ifTrue: [ ^ '@' ] ].
	^ '~'! !

!BigCaptainCell methodsFor: 'testing' stamp: 'MihaiCodoban 5/4/2013 17:52'!
hit
	noOfHits = 0
		ifTrue: [ 
			noOfHits := noOfHits + 1.
			super hit.
			^ 'Miss' ].
	noOfHits = 1
		ifTrue: [ 
			noOfHits := noOfHits + 1.
			ship destroy.
			^ 'Sunk' , ship name ].
	noOfHits := noOfHits + 1.
	^ 'Miss'! !

!BigCaptainCell methodsFor: 'initialize-release' stamp: 'YuLin 5/2/2013 17:29'!
initialize
	noOfHits := 0! !

!BigCaptainCell methodsFor: 'accessing' stamp: 'YuLin 5/2/2013 16:50'!
isHit
	noOfHits > 1
		ifTrue: [ ^ true ].
	^ false! !

!BigCaptainCell methodsFor: 'testing' stamp: 'YuLin 5/2/2013 16:49'!
isOccupied
	^true! !

!BigCaptainCell methodsFor: 'accessing' stamp: 'YuLin 5/2/2013 16:40'!
ship: aShip
	ship := aShip.
	ship addCell: self! !

!Cell methodsFor: 'accessing' stamp: 'YuLin 5/2/2013 16:20'!
getCharStatus
	self subclassResponsibility ! !

!Cell methodsFor: 'testing' stamp: 'YuLin 5/2/2013 16:17'!
hit
	isHit := true.
	^''! !

!Cell methodsFor: 'initialize-release' stamp: 'YuLin 5/2/2013 17:28'!
initialize 
	isHit := false! !

!Cell methodsFor: 'accessing' stamp: 'YuLin 5/2/2013 16:18'!
isHit
	^isHit! !

!Cell methodsFor: 'testing' stamp: 'YuLin 5/2/2013 16:19'!
isOccupied
	self subclassResponsibility ! !

Cell subclass: #ShipCell
	instanceVariableNames: 'ship'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

!ShipCell methodsFor: 'accessing' stamp: 'YuLin 5/2/2013 16:34'!
getCharStatus
	self isHit
		ifTrue: [ ^ '@' ]
		ifFalse: [ ^ '~' ]! !

!ShipCell methodsFor: 'testing' stamp: 'YuLin 5/2/2013 16:29'!
hit
	self isHit
		ifTrue: [ ^ 'Miss' ]
		ifFalse: [ 
			super hit.
			^ 'Hit' ]! !

!ShipCell methodsFor: 'testing' stamp: 'YuLin 5/2/2013 16:29'!
isOccupied
	^true! !

!ShipCell methodsFor: 'initialize-release' stamp: 'YuLin 5/2/2013 16:25'!
ship: aShip
	ship := aShip.
	ship addCell: self! !

Cell subclass: #SmallCaptainCell
	instanceVariableNames: 'ship'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

!SmallCaptainCell methodsFor: 'accessing' stamp: 'YuLin 5/2/2013 17:00'!
getCharStatus
	self isHit
		ifTrue: [ ^ '@' ].
	^ '~'! !

!SmallCaptainCell methodsFor: 'testing' stamp: 'MihaiCodoban 5/4/2013 17:52'!
hit
	self isHit
		ifFalse: [ 
			super hit.
			ship destroy.
			^ 'Sunk', ship name ].
	^ 'Miss'! !

!SmallCaptainCell methodsFor: 'testing' stamp: 'YuLin 5/2/2013 16:59'!
isOccupied
	^true! !

!SmallCaptainCell methodsFor: 'accessing' stamp: 'YuLin 5/2/2013 16:56'!
ship: aShip
	ship := aShip.
	ship addCell: self! !

Cell subclass: #WaterCell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

!WaterCell methodsFor: 'accessing' stamp: 'YuLin 5/2/2013 17:03'!
getCharStatus
	self isHit ifTrue: [ ^'x' ].
	^'~'! !

!WaterCell methodsFor: 'testing' stamp: 'YuLin 5/2/2013 17:02'!
hit 
	^'Miss'! !

!WaterCell methodsFor: 'testing' stamp: 'YuLin 5/2/2013 17:02'!
isOccupied 
	^false! !

Object subclass: #Grid
	instanceVariableNames: 'gridHeight gridWidth cells nrOfavailableShips'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

!Grid methodsFor: 'update' stamp: 'MihaiCodoban 5/4/2013 12:05'!
at: aPoint addShip: aShip
	aShip placeOnGrid: self at: aPoint.
	nrOfavailableShips := nrOfavailableShips + 1.
	aShip subscribe: self! !

!Grid methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/3/2013 14:30'!
at: coordinate placeCell: aCell
 	cells at: coordinate x at: coordinate y put:  aCell! !

!Grid methodsFor: 'initialize-release' stamp: 'YuLin 5/2/2013 20:50'!
height: aHeight width: aWidth
	| i j |
	i := 1.
	gridHeight := aHeight.
	gridWidth := aWidth.
	nrOfavailableShips := 0.
	cells := Matrix rows: aHeight columns: aWidth.
	[ i <= aHeight ]
		whileTrue: [ 
			j := 1.
			[ j <= aWidth ]
				whileTrue: [ 
					cells at: i at: j put: WaterCell new.
					j := j + 1 ].
			i := i + 1 ]! !

!Grid methodsFor: 'update' stamp: 'YuLin 5/2/2013 20:56'!
hit: aPoint
	| result |
	result := (cells at: (aPoint x) at: (aPoint y)) hit.
	nrOfavailableShips = 0
		ifTrue: [ result := 'Surrender' ].
	^ result! !

!Grid methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/4/2013 12:02'!
isCellOccupiedat: point
	^(cells at: point x at: point y) isOccupied ! !

!Grid methodsFor: 'print' stamp: 'YuLin 5/2/2013 20:52'!
peekGridToGui
	| toReturn i j cell |
	i := 1.
	toReturn := Matrix rows: gridHeight columns: gridWidth.
	[ i <= gridHeight ]
		whileTrue: [ 
			j := 1.
			[ j <= gridWidth ]
				whileTrue: [ 
					cell := cells at: i at: j.
					toReturn at: i at: j put: cell getCharStatus.
					j := j + 1 ].
			i := i + 1 ].
	^ toReturn! !

!Grid methodsFor: 'print' stamp: 'YuLin 5/2/2013 20:51'!
peekMyGridToGui
	| toReturn i j cell |
	i := 1.
	toReturn := Matrix rows: gridHeight columns: gridWidth.
	[ i <= gridHeight ]
		whileTrue: [ 
			j := 1.
			[ j <= gridWidth ]
				whileTrue: [ 
					cell := cells at: i at: j.
					toReturn at: i at: j put: '~'.
					cell isOccupied ifTrue: [ toReturn at: i at: j put: 'B'. ].
					j := j + 1 ].
			i := i + 1 ].
	^ toReturn! !

Object subclass: #HitResult
	instanceVariableNames: 'isMiss isSunk isSurrender affectedShip isHit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

!HitResult methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/4/2013 18:00'!
asString
	self isSurrender
		ifTrue: [ ^ 'SURRENDER' ].
	self isSunk
		ifTrue: [ ^ 'SUNK ' , affectedShip name ].
	self isHit
		ifTrue: [ ^ 'HIT' ].
	^ 'MISS'! !

!HitResult methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/4/2013 17:36'!
hit
	isHit := true.! !

!HitResult methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/4/2013 17:36'!
initialize 
	isHit := false.
	isSunk := false.
	isSurrender := false.! !

!HitResult methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/4/2013 17:41'!
isHit
	^isHit! !

!HitResult methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/4/2013 17:41'!
isSunk
 ^isSunk! !

!HitResult methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/4/2013 17:41'!
isSurrender
	^isSurrender! !

!HitResult methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/4/2013 18:00'!
sunk: aShip 
	isSunk := true.
	affectedShip := aShip.! !

!HitResult methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/4/2013 17:59'!
surrender
	isSurrender := true.! !

Object subclass: #Layout
	instanceVariableNames: 'layout rotated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

!Layout class methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/3/2013 13:30'!
withLayout: aLayout 
	|newLayout  |
	newLayout  := self new.
	newLayout initializeWith: aLayout.
	
	^newLayout! !

!Layout methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/3/2013 13:38'!
initializeWith: aLayout 
	self layout: ((aLayout findTokens: '|') at: 1) .
	rotated := false.! !

!Layout methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/2/2013 19:28'!
layout
	^layout.! !

!Layout methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/2/2013 19:15'!
layout: aLayout 	
 layout := aLayout .! !

!Layout methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/4/2013 16:40'!
rotate
	self rotated not
		ifTrue: [ 
			self rotateCW.
			self rotated: true ]
		ifFalse: [ 
			self rotateCCW.
			self rotated: false ]! !

!Layout methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/4/2013 16:40'!
rotateCCW
	"D->R
	L->D
	R->U
	U->L"
	
	| newLayout |
	newLayout := ''.
	
	self layout do: [ :direction |
		direction = $d ifTrue: [ newLayout := newLayout, 'r' ].
		direction = $l ifTrue: [ newLayout := newLayout, 'd' ].
		direction = $r ifTrue: [ newLayout := newLayout, 'u' ].
		direction = $u ifTrue: [ newLayout := newLayout, 'l' ].
		 ].
	
	self layout: newLayout.! !

!Layout methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/4/2013 16:40'!
rotateCW 
	"D->L
	L->U
	R->D
	U->R"
	
	| newLayout |
	newLayout := ''.
	
	self layout do: [ :direction |
		direction = $d ifTrue: [newLayout := newLayout, 'l' ].
		direction = $l ifTrue: [ newLayout := newLayout, 'u' ].
		direction = $r ifTrue: [ newLayout := newLayout, 'd' ].
		direction = $u ifTrue: [ newLayout := newLayout, 'r' ].
		 ].
	
	self layout: newLayout.! !

!Layout methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/3/2013 13:38'!
rotated
 ^rotated! !

!Layout methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/3/2013 13:33'!
rotated: aBoolean
	rotated := aBoolean! !

Layout subclass: #ShipLayout
	instanceVariableNames: 'shipParts ship'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

!ShipLayout class methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/3/2013 12:49'!
withLayout: aLayout forShip: aShip
	| shipLayout shipParts parts |
	shipLayout := self withLayout: aLayout.
	
	parts := aLayout findTokens: '|'.
	shipParts := parts copyFrom: 2 to: (parts) size.
	
	shipLayout shipParts: shipParts.
	shipLayout ship: aShip.
	
	^ shipLayout! !

!ShipLayout methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/4/2013 11:39'!
constructShipLayoutParts
	"merges the layout and ship parts"

	| shipLayoutParts direction cell |
	shipLayoutParts := OrderedCollection new.	"TODO: use two collection iteration technique "
		
	1 to: self layout size do: [ :i | 
		direction := self layout at: i.
		cell := (Smalltalk at: (shipParts at: i) asSymbol) new.
		cell ship: self ship.
		shipLayoutParts add: (ShipLayoutPart withDirection: direction andCell: cell) ].
	^ shipLayoutParts! !

!ShipLayout methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/2/2013 21:06'!
getCellTypeAt: index! !

!ShipLayout methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/2/2013 21:07'!
getCells! !

!ShipLayout methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/2/2013 21:58'!
getNextPointFor: point with: direction 
	direction = $d
		ifTrue: [ ^ point down ].
	direction = $u
		ifTrue: [ ^ point up ].
	direction = $r
		ifTrue: [ ^ point right ].
	direction = $l
		ifTrue: [ ^ point left ].! !

!ShipLayout methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/4/2013 16:53'!
makeShipCellsAt: point
	| shipCells varPoint shipLayoutParts |
	shipCells := Dictionary new.
	varPoint := point.
	
	shipLayoutParts := self constructShipLayoutParts.

	shipLayoutParts do: [ :shipLayoutPart | 
			self halt.
			shipCells at: varPoint put: shipLayoutPart cell.
			varPoint := self getNextPointFor: varPoint with: (shipLayoutPart direction) ].
	^ shipCells! !

!ShipLayout methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/3/2013 13:18'!
ship
	^ ship! !

!ShipLayout methodsFor: 'as yet unclassified' stamp: 'YuLin 5/3/2013 15:32'!
ship: aShip
	ship := aShip! !

!ShipLayout methodsFor: 'as yet unclassified' stamp: 'YuLin 5/3/2013 15:33'!
shipParts: aShipParts 
	shipParts := aShipParts ! !

Object subclass: #Player
	instanceVariableNames: 'grid playerName factory endGameObservers gridObservers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

!Player methodsFor: 'update' stamp: 'MihaiCodoban 5/4/2013 16:51'!
addShip: shipName at: aPoint rotated: isRotated
	| ship |

	ship := factory buildShip: shipName rotated: isRotated.
	grid at: aPoint addShip: ship! !

!Player methodsFor: 'print' stamp: 'YuLin 5/2/2013 20:17'!
endGameInterrogate
	^ playerName + 'lost the game'! !

!Player methodsFor: 'update' stamp: 'YuLin 5/2/2013 20:18'!
gridChangeInterrogate
	^ self peekGridToGui: nil! !

!Player methodsFor: 'initialize-release' stamp: 'YuLin 5/2/2013 19:52'!
gridHeight: aHeight gridWidth: aWidth name: aName factory: aFactory
	playerName := aName.
	factory := aFactory .
	grid := Grid new height: aHeight width: aWidth.! !

!Player methodsFor: 'update' stamp: 'YuLin 5/2/2013 20:57'!
hit: aPoint
	|result|
	result := grid hit: aPoint.
	(result = 'Surrender') ifTrue: [ self notifyEndGame ].
	self notifyGridChanges.
	^result ! !

!Player methodsFor: 'initialize-release' stamp: 'YuLin 5/2/2013 20:00'!
initialize 
	endGameObservers := OrderedCollection new.
	gridObservers := OrderedCollection new! !

!Player methodsFor: 'print' stamp: 'MihaiCodoban 5/4/2013 17:52'!
name
	^playerName ! !

!Player methodsFor: 'observer' stamp: 'YuLin 5/2/2013 20:14'!
notifyEndGame
	endGameObservers do: [ :each | each notifyForEndGame ].! !

!Player methodsFor: 'observer' stamp: 'YuLin 5/2/2013 20:12'!
notifyGridChanges
	gridObservers do: [:each | each notifyForGridChange]! !

!Player methodsFor: 'print' stamp: 'YuLin 5/2/2013 20:10'!
peekGridToGui: player
	player == self
		ifTrue: [ ^ grid peekMyGridToGui ]
		ifFalse: [ ^ grid peekGridToGui ]! !

!Player methodsFor: 'observer' stamp: 'YuLin 5/2/2013 20:15'!
subscribeEndGameObserver: o
	endGameObservers add: o! !

!Player methodsFor: 'observer' stamp: 'YuLin 5/2/2013 20:16'!
subscribeToGridChanges: o
	gridObservers add: o! !

!Player methodsFor: 'observer' stamp: 'YuLin 5/2/2013 20:15'!
unsubscribeEndGameObserver: o
	endGameObservers remove: o! !

!Player methodsFor: 'observer' stamp: 'YuLin 5/2/2013 20:16'!
unsubscribeToGridChanges: o
	gridObservers remove: o! !

Object subclass: #Ship
	instanceVariableNames: 'name cells shipLayout destroyed is'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

!Ship class methodsFor: 'as yet unclassified' stamp: 'YuLin 5/3/2013 15:37'!
named: aName withLayout: aLayout
	^ Ship new named: aName withLayout: aLayout.! !

!Ship methodsFor: 'adding' stamp: 'MihaiCodoban 5/2/2013 19:01'!
addCell: aCell
	cells add: aCell.! !

!Ship methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/3/2013 14:24'!
checkCollisionOf: shipCells with: aGrid
	shipCells keys
		do: [ :coordinate | 
			(aGrid isCellOccupiedat: coordinate)
				ifTrue: [ GridCollisionError signal ] ]! !

!Ship methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/2/2013 20:03'!
destroy
	cells do: [ :eachCell | eachCell hit  ].
	destroyed := True.
	"notify observers"! !

!Ship methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/2/2013 20:02'!
isDistroyed
	^ destroyed! !

!Ship methodsFor: 'accessing' stamp: 'MihaiCodoban 5/4/2013 17:54'!
name
	^name! !

!Ship methodsFor: 'as yet unclassified' stamp: 'YuLin 5/3/2013 15:29'!
named: aName withLayout: aLayout
	name := aName.
	shipLayout := ShipLayout withLayout: aLayout forShip: self.
	cells := OrderedCollection new.! !

!Ship methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/3/2013 14:30'!
placeOnGrid: aGrid at: point
	| shipCells |
	shipCells := shipLayout makeShipCellsAt: point.
	
	self checkCollisionOf: shipCells with: aGrid.
	
	shipCells keysAndValuesDo: [ : coordinate : shipCell | aGrid at: coordinate placeCell: shipCell].	! !

!Ship methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/2/2013 20:01'!
rotate
	shipLayout rotate! !

!Ship methodsFor: 'as yet unclassified' stamp: 'YuLin 5/2/2013 19:24'!
subscribe: grid! !

Object subclass: #ShipFactory
	instanceVariableNames: 'layoutCatalogue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

!ShipFactory class methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/3/2013 13:54'!
new
	^ super new initialize! !

!ShipFactory methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/4/2013 11:45'!
buildShip: shipName
	^ self buildShip: shipName rotated: false.! !

!ShipFactory methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/4/2013 11:44'!
buildShip: shipName rotated: rotation
	| ship |
	ship := Ship named: shipName withLayout: (layoutCatalogue at: shipName).
	rotation ifTrue: [ ship rotate  ].
	
	^ship! !

!ShipFactory methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/3/2013 14:01'!
initialize
	layoutCatalogue := Dictionary new.
	
	layoutCatalogue at: 'Minesweeper' put: 'rr|SmallCaptainCell|ShipCell'.
	layoutCatalogue at: 'Destroyer' put: 'rrr|ShipCell|BigCaptainCell|ShipCell'.
	layoutCatalogue at: 'Battleship' put: 'rrrr|ShipCell|ShipCell|BigCaptainCell|ShipCell'.
	! !

!ShipFactory methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/3/2013 14:02'!
showShipNames
	^layoutCatalogue keys 
! !

Object subclass: #ShipLayoutPart
	instanceVariableNames: 'direction cell'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

!ShipLayoutPart class methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/2/2013 21:50'!
withDirection: aDirection andCell: aCell
	| part |
	part := self new.
	part direction: aDirection.
	part cell: aCell.
	^ part! !

!ShipLayoutPart methodsFor: 'as yet unclassified' stamp: 'YuLin 5/3/2013 15:44'!
cell
	^cell! !

!ShipLayoutPart methodsFor: 'as yet unclassified' stamp: 'YuLin 5/3/2013 15:42'!
cell: aCell 
	cell := aCell! !

!ShipLayoutPart methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/4/2013 11:51'!
direction
	^direction! !

!ShipLayoutPart methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/2/2013 21:50'!
direction: aDirection
	direction := aDirection.! !

!ShipLayoutPart methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/2/2013 21:50'!
withCell: aCell 
	cell := aCell.! !
